var HUD = {};

HUD.init = function()
{
	HUD.heart = ResourceManager.loadImage("art/ui/heart.png");
	
	HUD.menu = ResourceManager.loadImage("art/ui/title.png");
	HUD.pause = ResourceManager.loadImage("art/ui/pause.png");
	HUD.over = ResourceManager.loadImage("art/ui/over.png");
};

HUD.draw = function()
{
	HUD.drawHealth();
	HUD.drawScore();
};

HUD.drawHealth = function()
{
	var x = 3;
	for(var i = 0; i < player.health; i++)
	{
		Camera.drawImage(HUD.heart, x + (i * 10), 3, 7, 8);	
	}
};

HUD.drawScore = function()
{
	//console.log(score);
	Camera.context.font=(10*Camera.scale) + "px Georgia";
	Camera.context.fillStyle= "white";
	Camera.context.fillText("Score: "+score , (400*Camera.scale), (20*Camera.scale));
	
	var high = score;
	if( localStorage["highScore"] != null)
	{
		if(score > localStorage["highScore"])
			localStorage["highScore"] = score;
		else
			high = localStorage["highScore"];
	}
	
	Camera.context.font=(10*Camera.scale) + "px Georgia";
	Camera.context.fillStyle= "white";
	Camera.context.fillText("High Score: "+high , (400*Camera.scale), (10*Camera.scale));
};

HUD.drawMenu = function()
{
	Camera.drawImage(HUD.menu, 0, 0, 480, 270);
	HUD.drawScore();
};

HUD.drawPause = function()
{
	Camera.drawImage(HUD.pause, 0, 0, 480, 270);
};

HUD.drawGameOver = function()
{
	Camera.drawImage(HUD.over, 0, 0, 480, 270);
	HUD.drawScore();
};