var BaddieManager = {};

BaddieManager.baddies;
BaddieManager.corpses;

BaddieManager.init = function()
{
	BaddieManager.baddies = [];
	BaddieManager.corpses = [];
	
	BaddieManager.shadow = ResourceManager.loadImage("art/player/guyShadow.png");
	BaddieManager.guy = ResourceManager.loadImage("art/enemies/brownGuy.png");
	
	BaddieManager.guyLeft = ResourceManager.loadImage("art/enemies/brownGuy_left.png");
	BaddieManager.guyRight = ResourceManager.loadImage("art/enemies/brownGuy_right.png");
	
	BaddieManager.dead = ResourceManager.loadImage("art/enemies/brownGuyDead.png");
	
	BaddieManager.guyPrep_right = ResourceManager.loadImage("art/enemies/brownGuyPrepare_right.png");
	BaddieManager.guyAttack_right = ResourceManager.loadImage("art/enemies/brownGuyAttack_right.png");
	
	BaddieManager.guyPrep_left = ResourceManager.loadImage("art/enemies/brownGuyPrepare_left.png");
	BaddieManager.guyAttack_left = ResourceManager.loadImage("art/enemies/brownGuyAttack_left.png");
	
	BaddieManager.guyAttackSwoosh_left = ResourceManager.loadImage("art/enemies/brownGuyAttackSwoosh_left.png");
	BaddieManager.guyAttackSwoosh_right = ResourceManager.loadImage("art/enemies/brownGuyAttackSwoosh_right.png");
	
	//sounds
	BaddieManager.hitSound = ResourceManager.loadSound("sound/zombie_hit.wav");
	BaddieManager.missSound = ResourceManager.loadSound("sound/zombie_miss.wav");
	BaddieManager.combineSound = ResourceManager.loadSound("sound/combine.wav");
	
	
	BaddieManager.oneImage = ResourceManager.loadImage("art/enemies/no_1.png");
	BaddieManager.twoImage = ResourceManager.loadImage("art/enemies/no_2.png");
	BaddieManager.fourImage = ResourceManager.loadImage("art/enemies/no_4.png");
	BaddieManager.eightImage = ResourceManager.loadImage("art/enemies/no_8.png");
	BaddieManager.sixteenImage = ResourceManager.loadImage("art/enemies/no_16.png");
	BaddieManager.thirtyTwoImage = ResourceManager.loadImage("art/enemies/no_32.png");
	BaddieManager.sixtyFourImage = ResourceManager.loadImage("art/enemies/no_64.png");
	BaddieManager.oneTwentyEightImage = ResourceManager.loadImage("art/enemies/no_128.png");
	BaddieManager.twoFiftySixImage = ResourceManager.loadImage("art/enemies/no_256.png");
	BaddieManager.fiveTwelveImage = ResourceManager.loadImage("art/enemies/no_512.png");
	BaddieManager.tenTwentyFourImage = ResourceManager.loadImage("art/enemies/no_1024.png");
	BaddieManager.twentyFortyEightImage = ResourceManager.loadImage("art/enemies/no_2048.png");
};

BaddieManager.spawnFreshBaddie = function()
{
	
	var baddie = new Zombie(1, BaddieManager.getSpawnPos(), BaddieManager.oneImage);
	
	BaddieManager.baddies.push(baddie);
};

BaddieManager.getSpawnPos = function()
{
	//var angle = Util.angleTo(player.position, {x: 232, y: 115});
		
	var x = 0;//232 + Math.cos(angle ) * 335;
	var y = 0;//115 + Math.sin(angle ) * 235;
	
	if(player.position.x <= 232 )
		x = 510;
	else
		x = -30;
		
	y = Util.getRandomNumber(300) - 30;
			
	return {
		x: x,
		y: y
	};
};

BaddieManager.dealWithDeath = function(zombie)
{
	score += zombie.type;
	
	Util.removeByValue(BaddieManager.baddies, zombie);
	
	var corpse = new Corpse(zombie.type, zombie.position, zombie.image);
	
	BaddieManager.corpses.push(corpse);
	
	
	if(BaddieManager.baddies.length < MAX_BADDIES)
		BaddieManager.spawnFreshBaddie();
};

BaddieManager.combineCorpses = function(corpseA, corpseB)
{
	Util.removeByValue(BaddieManager.corpses, corpseA);
	Util.removeByValue(BaddieManager.corpses, corpseB);
	
	corpseA.combined = false;
	corpseB.combined = false;
	
	var newType = corpseA.type + corpseB.type;
	
	var img = BaddieManager.oneImage;
	switch(newType)
	{
		case 1: img = 	BaddieManager.oneImage;
						break;
						
		case 2: img = 	BaddieManager.twoImage;
						break;
						
		case 4: img = 	BaddieManager.fourImage;
						break;
						
		case 8: img = 	BaddieManager.eightImage;
						break;
						
		case 16: img = 	BaddieManager.sixteenImage;
						break;
						
		case 32: img = 	BaddieManager.thirtyTwoImage;
						break;
						
		case 64: img = 	BaddieManager.sixtyFourImage;
						break;
						
		case 128: img = BaddieManager.oneTwentyEightImage;
						break;
						
		case 256: img = BaddieManager.twoFiftySixImage;
						break;
						
		case 512: img = BaddieManager.fiveTwelveImage;
						break;
						
		case 1024: img =BaddieManager.tenTwentyFourImage;
						break;
						
		case 2048: img =BaddieManager.twentyFortyEightImage;
						break;				
	}
	
	var baddie = new Zombie(newType, corpseA.position, img);
	
	BaddieManager.baddies.push(baddie);
	
	
};

BaddieManager.updateAll = function()
{
	for(var i = 0; i < BaddieManager.baddies.length; i++)
	{
		BaddieManager.baddies[i].update();
	}
	
	for(var i = 0; i < BaddieManager.corpses.length; i++)
	{
		BaddieManager.corpses[i].update();
	}
};

BaddieManager.drawAll = function()
{
	for(var i = 0; i < BaddieManager.baddies.length; i++)
	{
		BaddieManager.baddies[i].draw();
	}
};